#templating

class Parser:
	def __init__(self, file):
		self.lineCallback = None
		self.lineNumber = 0
		self.filename = file
		self.linesOut = None
		with open(file) as f:
			self.lines = f.readlines()
	
	def setLineCallback(self, cb):
		self.lineCallback = cb
	
	def parse(self):
		self.discardCurrentLine = False
		self.linesOut = []
		self.line = ''
		pyCode = ''
		self.pyGlobals = {}
		collectCode = False
		self.lineNumber = 0
		for line in self.lines:
			self.lineNumber += 1
			line = line.rstrip()
			ls = line.lstrip()
			if ls[:2] == '%>':
				if not collectCode:
					raise Error('not in a python code block')
				collectCode = False
				exec(pyCode, self.pyGlobals)
				continue
			if collectCode:
				pyCode += line
				continue
			if ls[:2] == '<%':
				if collectCode:
					raise Error('already in a python code block')
				pyCode = ls[2:]
				collectCode = True
				continue
			
			self.line = self.replaceEvals(line)
			#line callback if line isn't python code
			if not collectCode and self.lineCallback != None:
				self.lineCallback()
			
			if not self.discardCurrentLine:
				self.linesOut.append(self.line)
			else:
				self.discardCurrentLine = False
		return self.linesOut
	
	def discardLine(self):
		self.discardCurrentLine = True
	
	def insertLine(self, text):
		self.linesOut.append(text)
		
	def out(self,text):
		lines = text.split('\n')
		for l in lines:
			self.lines.insert(self.lineNumber, l)
	
	def replaceEvals(self,line):
		while True:
			pos = line.find('${')
			if pos!=-1:
				expr = line[pos+2:]
				pos2 = expr.find('}')
				if pos2!=-1:
					expr = expr[:pos2]
					res = eval(expr,self.pyGlobals)
					line = line[:pos] + str(res) + line[pos+pos2+3:]
				else:
					raise Error("missing closing '}'")
			else:
				break
		return line
		
	'''def findInPythonCode(self, code, sub):
		'code2 = '' #TODO: skip strings?
		quotes = ''
		skipNext = False
		for c in code:
			if skipNext:
				skipNext = False
				continue
			if quotes != '':
				if c=='\\':
					skipNext = True
				code2 += '#' #fill strings with garbage characters
			if c=='"' or c=="'":
				if quotes=='':
					quotes = c
				elif quotes==c:
					quotes = ''
		'
		#searches in strings as well for now, makes it mandatory to not use %> in python strings
		#TODO: implement properly
		return code.find(sub)'''
	

class Error:
	def __init__(self, msg):
		self.msg = msg

